/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	Spellista

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_playlist_h
#define mp3_playlist_h

#include <stdio.h>
#include <zz_string.h>
#include <zz_win_threadmutex.h>
#include <map>
#include <zz_log.h>

typedef map<CzzString, unsigned int>	Cmp3IndexMap;
typedef map<unsigned int, CzzString>	Cmp3StringMap;

class Cmp3PlayList
{
public:

	//* Construction
	Cmp3PlayList( const CzzString& usr );
	~Cmp3PlayList();


	void add( const char* name, const char* album, const char* song );
	void clear();
	void forward();
	void reverse();
	void randomize();
	void remove( const char* name, const char* album, const char* song );
	FILE* getNextStreamHandle();
	CzzString nowPlaying();
	CzzString commingUp();
	CzzString lastPlayed();
	CzzString list();
	CzzString listIndexes();
	void replacePlaylist( const char* name );
	int getBitRate( void );
		
protected:
private:

	int getBitRate( const char* file );

	void readRadioPlayList();
	void saveRadioPlayList();

	static CzzString readID3( const char* file );

	CzzLog m_Log;
	FILE* m_nowPlayingFileHande;
	CzzString m_nowPlayingSong;
	CzzWinThreadMutex m_Mutex;
	int m_nowPlaying;
	int m_skipIndicator;
	Cmp3IndexMap m_IndexMap;
	Cmp3StringMap m_StringMap;
	CzzString m_User;

	int m_BitRate;
};

#endif // mp3_playlist_h