/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3ErrorRender

#include "mp3_error_render.h"
#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"
#include "mp3_error_data.h"

// Construction
Cmp3ErrorRender::Cmp3ErrorRender( void* session, CzzParameterMap* cgi, const CzzString& msg )
: CzzOutputRender( CzzString::Format( ".\\%s\\%s\\renderException.html", Cmp3Config::getLang().c_str(), Cmp3Config::getSkin().c_str() ) , session, cgi )
{

	CzzString back_url = CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=A", 
											Cmp3Config::getCGIDir().c_str(), 
											MP3_SVC_LIST_ARTISTS );

	this->addFieldSvc( new Cmp3GeneralData( back_url, "myMusic", 
		CzzString::Format( "Error - %s", msg.c_str() )));

	this->addFieldSvc( new Cmp3ErrorData( msg ) );

}

// Destruction
Cmp3ErrorRender::~Cmp3ErrorRender()
{

}

