/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	HTTP requester for queries to the radio-source

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_http_requester_h
#define mp3_http_requester_h

#include <zz_http.h>
#include <zz_log.h>

class Cmp3HttpRequester : public CzzHTTP
{
public:

	//* Construction
	Cmp3HttpRequester( void );
	Cmp3HttpRequester( char* host, char* port );
	virtual ~Cmp3HttpRequester();

	void addSongToRadioQueue( const char* name, const char* album, const char* song );
	void removeFromRadioQueue( const char* name, const char* album, const char* song );
	void clearRadioQueue( void );
	void skipForwardRadioQueue( void );
	void skipReverseRadioQueue( void );
	void randomizeRadioQueue( void );
	void replaceRadioQueue( const char* name );
	CzzString listRadioQueue( void );
	CzzString listIndexesRadioQueue( void );
	CzzString nowPlaying( void );
	CzzString commingUp( void );
	CzzString checkLicense( const CzzString& lnr );
	
protected:
	virtual void writeToFile( long from, long size );

private:

	CzzString getUser( void );

	CzzLog m_Log;
	CzzString m_Buffer;
	CzzString m_User;
};

#endif // mp3_http_requester_h