/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3MyRadioData

#include "mp3_http_requester.h"
#include "mp3_myradio_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"

// Construction
Cmp3MyRadioData::Cmp3MyRadioData( void )
: CzzDataService( "getMyRadioData" )
{

}

// Destruction
Cmp3MyRadioData::~Cmp3MyRadioData()
{

}

CzzDataServiceReply* Cmp3MyRadioData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzString now = "-";
	CzzString next = "-";
	CzzDataServiceReply* reply = new CzzDataServiceReply();


	try
	{
		Cmp3HttpRequester req;
		now = req.nowPlaying();
		next = req.commingUp();
	}
	catch( ... ) {}

	reply->addField( MP3_FLD_RADIO_NAME, Cmp3Config::getLocalRadioName() );
	reply->addField( MP3_FLD_RADIO_NOW_PLAYING, "&raquo; " + now );
	reply->addField( MP3_FLD_RADIO_COMMING_UP, "&#8226; " + next );
	reply->addField( MP3_FLD_PLAY_LINK, CzzString::Format( "%s/mp3_playlist.exe?svc=6", Cmp3Config::getCGIDir().c_str() ) );
	reply->addField( MP3_FLD_RAND_RADIO_LINK, CzzString::Format( "%s/mp3_gui.exe?svc=%d", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_RADIO_RAND ) );
	reply->addField( MP3_FLD_SKIP_BACKWARD, CzzString::Format( "%s/mp3_gui.exe?svc=%d", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_RADIO_REVERSE ) );
	reply->addField( MP3_FLD_SKIP_FORWARD, CzzString::Format( "%s/mp3_gui.exe?svc=%d", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_RADIO_FORWARD ) );
	reply->addField( MP3_FLD_RADIO_EMPTY, CzzString::Format( "%s/mp3_gui.exe?svc=%d", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_RADIO_CLEAR ) );

	return reply;
}

int Cmp3MyRadioData::size()
{
    return sizeof(Cmp3MyRadioData);
}