/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3RecordListRender

#include "mp3_record_list_render.h"
#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_record_list_data.h"
#include "mp3_svc.h"

// Construction
Cmp3RecordListRender::Cmp3RecordListRender( void* session, CzzParameterMap* cgi )
 : CzzOutputRender( CzzString::Format( ".\\%s\\%s\\renderList.html", Cmp3Config::getLang().c_str(), Cmp3Config::getSkin().c_str() ), session, cgi )
{
	CzzString anchor;
	CzzString name = (*cgi)[ MP3_CGI_PAR_NAME ];

	if( name[0] == '0' || name[0] == '1' || name[0] == '2' || name[0] == '3' || name[0] == '4' || 
		name[0] == '5' || name[0] == '6' || name[0] == '7' || name[0] == '8' || name[0] == '9' )
		anchor = "0...9";
	else
		anchor = name.substr(0,1);

	CzzString back_url = CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(), 
											MP3_SVC_LIST_ARTISTS, anchor.c_str() );

	this->addFieldSvc( new Cmp3GeneralData( back_url, "myMusic", 
		CzzString::Format( "%s - %s", name.c_str(), Cmp3Config::HEADLINE_ALBUM_INDEX().c_str() )) );
	
	this->addListSvc( MP3_FLD_TABLE, new Cmp3RecordListData( ) );

}

// Destruction
Cmp3RecordListRender::~Cmp3RecordListRender()
{

}

