/* libzz
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_parameter_map_h
#define zz_parameter_map_h

#include <zz_string.h>

/**
	Parameter map, used as a baseclass for
    parameter parsing classes like CzzArguments and CzzCGIParameterParser

  	@author Toni Thomsson, toni@tonjac.org	
*/
class ZZ_API CzzParameterMap
{
public:

    /** Parameter map */
    CzzParameterMap();
    virtual ~CzzParameterMap();

    /** 
        Get variable by name
        @param var  Variablename
    */
    virtual CzzString operator[]( const CzzString& var ) = 0;

protected:
private:

};

#endif // zz_parameter_map_h