/* libzzsock
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_sock_exception_h
#define zz_sock_exception_h

#ifdef _WIN32
	#include <winsock2.h>
#else
	#include <sys/types.h>
	#include <sys/socket.h>	
	#include <netinet/in.h>
	#include <arpa/inet.h>
	#include <netdb.h>
	#include <unistd.h>
	#include <errno.h>
    /** Handle */
	typedef int SOCKET;
	#define INVALID_SOCKET -1
	#define SOCKET_ERROR -1
#endif

#include <zz_log_exception.h>
#include <zz_export.h>

/**
    TCP socket error

    @author Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzSockException : public CzzLogException
{
public:

	/**
        Create a socket error
        @param  line    Line in source file, use __LINE__
        @param  file   Source file, use __FILE__
	*/
	CzzSockException( int line,
						CzzString file );

	~CzzSockException();

private:
	CzzString GetLastSocketError( void );

};

#endif // zz_sock_exception_h
